import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:intl/intl.dart';
import 'package:pea_cremation/pages/aboutus/aboutus_page.dart';
import 'package:pea_cremation/pages/contact/contact_page.dart';
import 'package:pea_cremation/pages/menu/menu_viewmodel.dart';
import 'package:pea_cremation/pages/changepass/change_pass_page.dart';
import 'package:pea_cremation/pages/changepass/change_pass_view_model.dart';
import 'package:pea_cremation/pages/dead/dead_page.dart';
import 'package:pea_cremation/pages/dead/dead_page_view_model.dart';
import 'package:pea_cremation/pages/download/form_download_page.dart';
import 'package:pea_cremation/pages/download/form_download_view_model.dart';
import 'package:pea_cremation/pages/forgotpass/forgot_pass_page.dart';
import 'package:pea_cremation/pages/forgotpass/forgot_pass_page_view_model.dart';
import 'package:pea_cremation/pages/invoice/invoice/invoice_view_model.dart';
import 'package:pea_cremation/pages/invoice/invoice/invoice_view_page.dart';
import 'package:pea_cremation/pages/invoice/invoice_download_page.dart';
import 'package:pea_cremation/pages/invoice/invoice_download_view_model.dart';
import 'package:pea_cremation/pages/invoice/receipt/receipt_view_model.dart';
import 'package:pea_cremation/pages/invoice/receipt/receipt_view_page.dart';
import 'package:pea_cremation/pages/landing/landing_page.dart';
import 'package:pea_cremation/pages/landing/landing_page_view_model.dart';
import 'package:pea_cremation/pages/login/login_page.dart';
import 'package:pea_cremation/pages/login/login_page_view_model.dart';
import 'package:pea_cremation/pages/menu/menu_page.dart';
import 'package:pea_cremation/pages/news/news_page.dart';
import 'package:pea_cremation/pages/news/news_page_view_model.dart';
import 'package:pea_cremation/pages/payment/barcode_view.dart';
import 'package:pea_cremation/pages/payment/payment_page.dart';
import 'package:pea_cremation/pages/payment/payment_page_view_model.dart';
import 'package:pea_cremation/pages/personal/personal_page.dart';
import 'package:pea_cremation/pages/personal/personal_page_view_model.dart';
import 'package:pea_cremation/pages/register/register_page.dart';
import 'package:pea_cremation/pages/register/register_page_view_model.dart';
import 'package:pea_cremation/pea_cremation.dart';
import 'package:provider/provider.dart';

import 'pages/contact/contact_page.dart';

Future main() async {
  WidgetsFlutterBinding.ensureInitialized(); // ensure flutter initialized.
  Intl.defaultLocale = 'en_US';

  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    SystemChrome.setPreferredOrientations([
      DeviceOrientation.portraitUp,
      DeviceOrientation.portraitDown,
    ]);

    return MaterialApp(
      title: 'PEA',
      theme: ThemeData(
        primarySwatch: Colors.blue,
        visualDensity: VisualDensity.adaptivePlatformDensity,
        fontFamily: 'Kanit'
      ),
      home: ChangeNotifierProvider(
        // create: (context) => LandingPageViewModel(),
        // child: LandingPage(),
        create: (context) => MenuViewModel(),
        child: MenuPage(),
      ),
      routes: PEACremation.getRoutes(),
        onGenerateRoute: (routeSettings) {
          if (routeSettings.name == PersonalPage.routeName + "_")
            return PageRouteBuilder(pageBuilder: (_, a1, a2) => ChangeNotifierProvider(
              create: (context) => PersonalPageViewModel(),
              child: PersonalPage(),
            ));

          return null;
        }
    );
  }
}
